OGRE: OgreBites::TrayManager Class Reference

| OGRE 14.5 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
OgreBites::TrayManager Class Reference
Optional Components » Bites » Trays

Main class to manage a cursor, backdrop, trays and widgets. More...

`#include <OgreTrays.h>`

Inheritance diagram for OgreBites::TrayManager:
[legend]

## Public Member Functions
| TrayManager (const Ogre::String &name, Ogre::RenderWindow *window, TrayListener *listener=0)
| Creates backdrop, cursor, and trays.
virtual | ~TrayManager ()
| Destroys background, cursor, widgets, and trays.
virtual void | adjustTrays ()
| Fits trays to their contents and snaps them to their anchor locations.
bool | areFrameStatsVisible ()
bool | areTraysVisible ()
void | buttonHit (Button *button) override
| Destroys dialog widgets, notifies listener, and ends high priority session.
void | clearAllTrays ()
| Removes all widgets from all widget trays.
void | clearTray (TrayLocation trayLoc)
| Removes all widgets from a widget tray.
void | closeDialog ()
| Hides whatever dialog is currently showing.
Button * | createButton (TrayLocation trayLoc, const Ogre::String &name, const Ogre::String &caption, Ogre::Real width=0)
CheckBox * | createCheckBox (TrayLocation trayLoc, const Ogre::String &name, const Ogre::DisplayString &caption, Ogre::Real width=0)
DecorWidget * | createDecorWidget (TrayLocation trayLoc, const Ogre::String &name, const Ogre::String &templateName)
Label * | createLabel (TrayLocation trayLoc, const Ogre::String &name, const Ogre::DisplayString &caption, Ogre::Real width=0)
SelectMenu * | createLongSelectMenu (TrayLocation trayLoc, const Ogre::String &name, const Ogre::DisplayString &caption, Ogre::Real boxWidth, unsigned int maxItemsShown, const Ogre::StringVector &items=Ogre::StringVector())
SelectMenu * | createLongSelectMenu (TrayLocation trayLoc, const Ogre::String &name, const Ogre::DisplayString &caption, Ogre::Real width, Ogre::Real boxWidth, unsigned int maxItemsShown, const Ogre::StringVector &items=Ogre::StringVector())
Slider * | createLongSlider (TrayLocation trayLoc, const Ogre::String &name, const Ogre::DisplayString &caption, Ogre::Real trackWidth, Ogre::Real valueBoxWidth, Ogre::Real minValue, Ogre::Real maxValue, unsigned int snaps)
Slider * | createLongSlider (TrayLocation trayLoc, const Ogre::String &name, const Ogre::DisplayString &caption, Ogre::Real width, Ogre::Real trackWidth, Ogre::Real valueBoxWidth, Ogre::Real minValue, Ogre::Real maxValue, unsigned int snaps)
ParamsPanel * | createParamsPanel (TrayLocation trayLoc, const Ogre::String &name, Ogre::Real width, const Ogre::StringVector &paramNames)
ParamsPanel * | createParamsPanel (TrayLocation trayLoc, const Ogre::String &name, Ogre::Real width, unsigned int lines)
ProgressBar * | createProgressBar (TrayLocation trayLoc, const Ogre::String &name, const Ogre::DisplayString &caption, Ogre::Real width, Ogre::Real commentBoxWidth)
Separator * | createSeparator (TrayLocation trayLoc, const Ogre::String &name, Ogre::Real width=0)
TextBox * | createTextBox (TrayLocation trayLoc, const Ogre::String &name, const Ogre::DisplayString &caption, Ogre::Real width, Ogre::Real height)
SelectMenu * | createThickSelectMenu (TrayLocation trayLoc, const Ogre::String &name, const Ogre::DisplayString &caption, Ogre::Real width, unsigned int maxItemsShown, const Ogre::StringVector &items=Ogre::StringVector())
Slider * | createThickSlider (TrayLocation trayLoc, const Ogre::String &name, const Ogre::DisplayString &caption, Ogre::Real width, Ogre::Real valueBoxWidth, Ogre::Real minValue, Ogre::Real maxValue, unsigned int snaps)
void | customStageEnded () override
| This event is fired when a custom loading stage has been completed.
void | customStageStarted (const Ogre::String &description) override
| This event is fired when a custom loading stage is about to start.
void | destroyAllWidgets ()
| Destroys all widgets.
void | destroyAllWidgetsInTray (TrayLocation trayLoc)
| Destroys all widgets in a tray.
void | destroyWidget (const Ogre::String &name)
void | destroyWidget (TrayLocation trayLoc, const Ogre::String &name)
void | destroyWidget (TrayLocation trayLoc, size_t place)
void | destroyWidget (Widget *widget)
| Destroys a widget.
void | frameRendered (const Ogre::FrameEvent &evt) override
| Process frame events.
Ogre::OverlayContainer * | getBackdropContainer ()
Ogre::Overlay * | getBackdropLayer ()
Ogre::OverlayContainer * | getCursorContainer ()
Ogre::OverlayElement * | getCursorImage ()
Ogre::Overlay * | getCursorLayer ()
Ogre::Ray | getCursorRay (Ogre::Camera *cam)
| Returns a 3D ray into the scene that is directly underneath the cursor.
TrayListener * | getListener ()
unsigned int | getNumWidgets ()
| Gets the number of widgets in total.
Ogre::OverlayContainer * | getTrayContainer (TrayLocation trayLoc)
virtual Ogre::Real | getTrayPadding () const
Ogre::Overlay * | getTraysLayer ()
Widget * | getWidget (const Ogre::String &name)
| Gets a widget by name.
Widget * | getWidget (TrayLocation trayLoc, const Ogre::String &name)
| Gets a widget from a tray by name.
virtual Ogre::Real | getWidgetPadding () const
const WidgetList & | getWidgets (TrayLocation trayLoc) const
| Gets all the widgets of a specific tray.
virtual Ogre::Real | getWidgetSpacing () const
void | hideAll ()
void | hideBackdrop ()
void | hideCursor ()
void | hideFrameStats ()
| Hides frame statistics widget set.
void | hideLoadingBar ()
void | hideLogo ()
void | hideTrays ()
bool | isBackdropVisible ()
bool | isCursorVisible ()
bool | isDialogVisible ()
| Determines if any dialog is currently visible.
bool | isLoadingBarVisible ()
bool | isLogoVisible ()
void | labelHit (Label *label) override
| Toggles visibility of advanced statistics.
int | locateWidgetInTray (Widget *widget)
| Gets a widget's position in its tray.
bool | mouseMoved (const MouseMotionEvent &evt) override
| Updates cursor position.
bool | mousePressed (const MouseButtonEvent &evt) override
| Processes mouse button down events.
bool | mouseReleased (const MouseButtonEvent &evt) override
| Processes mouse button up events.
bool | mouseWheelRolled (const MouseWheelEvent &evt) override
void | moveWidgetToTray (const Ogre::String &name, TrayLocation trayLoc, size_t place=-1)
void | moveWidgetToTray (TrayLocation currentTrayLoc, const Ogre::String &name, TrayLocation targetTrayLoc, size_t place=-1)
void | moveWidgetToTray (TrayLocation currentTrayLoc, size_t currentPlace, TrayLocation targetTrayLoc, size_t targetPlace=-1)
void | moveWidgetToTray (Widget *widget, TrayLocation trayLoc, size_t place=-1)
| Adds a widget to a specified tray at given position, or at the end if unspecified or invalid.
void | refreshCursor ()
| Updates cursor position based on unbuffered mouse state.
void | removeWidgetFromTray (const Ogre::String &name)
void | removeWidgetFromTray (TrayLocation trayLoc, const Ogre::String &name)
void | removeWidgetFromTray (TrayLocation trayLoc, size_t place)
void | removeWidgetFromTray (Widget *widget)
| Removes a widget from its tray.
void | resourceGroupLoadStarted (const Ogre::String &groupName, size_t resourceCount) override
| This event is fired when a resource group begins loading.
void | resourceGroupScriptingStarted (const Ogre::String &groupName, size_t scriptCount) override
| This event is fired when a resource group begins parsing scripts.
void | resourceLoadEnded () override
| This event is fired when the resource has been loaded.
void | resourceLoadStarted (const Ogre::ResourcePtr &resource) override
| This event is fired when a declared resource is about to be loaded.
void | scriptParseEnded (const Ogre::String &scriptName, bool skipped) override
| This event is fired when the script has been fully parsed.
void | scriptParseStarted (const Ogre::String &scriptName, bool &skipThisScript) override
| This event is fired when a script is about to be parsed.
void | setListener (TrayListener *listener)
void | setTrayPadding (Ogre::Real padding)
void | setTrayWidgetAlignment (TrayLocation trayLoc, Ogre::GuiHorizontalAlignment gha)
| Sets horizontal alignment of a tray's contents.
void | setWidgetPadding (Ogre::Real padding)
void | setWidgetSpacing (Ogre::Real spacing)
void | showAll ()
void | showBackdrop (const Ogre::String &materialName=Ogre::BLANKSTRING)
| Displays specified material on backdrop, or the last material used if none specified.
void | showCursor (const Ogre::String &materialName=Ogre::BLANKSTRING)
| Displays specified material on cursor, or the last material used if none specified.
void | showFrameStats (TrayLocation trayLoc, size_t place=-1)
| Shows frame statistics widget set in the specified location.
void | showLoadingBar (unsigned int numGroupsInit=1, unsigned int numGroupsLoad=1, Ogre::Real initProportion=0.7f)
| Shows loading bar.
void | showLogo (TrayLocation trayLoc, size_t place=-1)
| Shows logo in the specified location.
void | showOkDialog (const Ogre::DisplayString &caption, const Ogre::DisplayString &message)
| Pops up a message dialog with an OK button.
void | showTrays ()
void | showYesNoDialog (const Ogre::DisplayString &caption, const Ogre::DisplayString &question)
| Pops up a question dialog with Yes and No buttons.
void | toggleAdvancedFrameStats ()
| Toggles visibility of advanced statistics.
void | windowUpdate ()
Public Member Functions inherited from OgreBites::TrayListener
virtual | ~TrayListener ()
virtual void | checkBoxToggled (CheckBox *box)
virtual void | itemSelected (SelectMenu *menu)
virtual void | okDialogClosed (const Ogre::DisplayString &message)
virtual void | sliderMoved (Slider *slider)
virtual void | yesNoDialogClosed (const Ogre::DisplayString &question, bool yesHit)
Public Member Functions inherited from Ogre::ResourceGroupListener
virtual | ~ResourceGroupListener ()
virtual void | resourceCreated (const ResourcePtr &resource)
| This event is fired when a resource was just created.
virtual void | resourceGroupLoadEnded (const String &groupName)
| This event is fired when a resource group finished loading.
virtual void | resourceGroupPrepareEnded (const String &groupName)
| This event is fired when a resource group finished preparing.
virtual void | resourceGroupPrepareStarted (const String &groupName, size_t resourceCount)
| This event is fired when a resource group begins preparing.
virtual void | resourceGroupScriptingEnded (const String &groupName)
| This event is fired when a resource group finished parsing scripts.
virtual void | resourcePrepareEnded (void)
| This event is fired when the resource has been prepared.
virtual void | resourcePrepareStarted (const ResourcePtr &resource)
| This event is fired when a declared resource is about to be prepared.
virtual void | resourceRemove (const ResourcePtr &resource)
| This event is fired when a resource is about to be removed.
Public Member Functions inherited from OgreBites::InputListener
virtual | ~InputListener ()
virtual bool | axisMoved (const AxisEvent &evt)
virtual bool | buttonPressed (const ButtonEvent &evt)
virtual bool | buttonReleased (const ButtonEvent &evt)
virtual bool | hatMoved (const HatEvent &evt)
virtual bool | keyPressed (const KeyboardEvent &evt)
virtual bool | keyReleased (const KeyboardEvent &evt)
virtual bool | textInput (const TextInputEvent &evt)
virtual bool | touchMoved (const TouchFingerEvent &evt)
virtual bool | touchPressed (const TouchFingerEvent &evt)
virtual bool | touchReleased (const TouchFingerEvent &evt)

## Static Public Member Functions
static Ogre::Vector2 | sceneToScreen (Ogre::Camera *cam, const Ogre::Vector3 &pt)
| Converts a 3D scene position to a 2D screen position (in relative screen size, 0.0-1.0).
static Ogre::Ray | screenToScene (Ogre::Camera *cam, const Ogre::Vector2 &pt)
| Converts a 2D screen coordinate (in pixels) to a 3D ray into the scene.

## Detailed Description

Main class to manage a cursor, backdrop, trays and widgets.

## Constructor & Destructor Documentation

## ◆ TrayManager()

OgreBites::TrayManager::TrayManager | ( | const Ogre::String & | name,
|  | Ogre::RenderWindow * | window,
|  | TrayListener * | listener = 0 )

Creates backdrop, cursor, and trays.

## ◆ ~TrayManager()

virtual OgreBites::TrayManager::~TrayManager | ( |  | ) |
| virtual

Destroys background, cursor, widgets, and trays.

## Member Function Documentation

## ◆ screenToScene()

Ogre::Ray OgreBites::TrayManager::screenToScene | ( | Ogre::Camera * | cam,
|  | const Ogre::Vector2 & | pt )
| static

Converts a 2D screen coordinate (in pixels) to a 3D ray into the scene.

## ◆ sceneToScreen()

Ogre::Vector2 OgreBites::TrayManager::sceneToScreen | ( | Ogre::Camera * | cam,
|  | const Ogre::Vector3 & | pt )
| static

Converts a 3D scene position to a 2D screen position (in relative screen size, 0.0-1.0).

## ◆ getTrayContainer()

Ogre::OverlayContainer * OgreBites::TrayManager::getTrayContainer | ( | TrayLocation | trayLoc | ) |
| inline

## ◆ getBackdropLayer()

Ogre::Overlay * OgreBites::TrayManager::getBackdropLayer | ( |  | ) |
| inline

## ◆ getTraysLayer()

Ogre::Overlay * OgreBites::TrayManager::getTraysLayer | ( |  | ) |
| inline

## ◆ getCursorLayer()

Ogre::Overlay * OgreBites::TrayManager::getCursorLayer | ( |  | ) |
| inline

## ◆ getBackdropContainer()

Ogre::OverlayContainer * OgreBites::TrayManager::getBackdropContainer | ( |  | ) |
| inline

## ◆ getCursorContainer()

Ogre::OverlayContainer * OgreBites::TrayManager::getCursorContainer | ( |  | ) |
| inline

## ◆ getCursorImage()

Ogre::OverlayElement * OgreBites::TrayManager::getCursorImage | ( |  | ) |
| inline

## ◆ setListener()

void OgreBites::TrayManager::setListener | ( | TrayListener * | listener | ) |
| inline

## ◆ getListener()

TrayListener * OgreBites::TrayManager::getListener | ( |  | ) |
| inline

## ◆ showAll()

void OgreBites::TrayManager::showAll | ( |  | ) |

## ◆ hideAll()

void OgreBites::TrayManager::hideAll | ( |  | ) |

## ◆ showBackdrop()

void OgreBites::TrayManager::showBackdrop | ( | const Ogre::String & | materialName = Ogre::BLANKSTRING | ) |

Displays specified material on backdrop, or the last material used if none specified.

Good for pause menus like in the browser.

References Ogre::BLANKSTRING.

## ◆ hideBackdrop()

void OgreBites::TrayManager::hideBackdrop | ( |  | ) |
| inline

## ◆ showCursor()

void OgreBites::TrayManager::showCursor | ( | const Ogre::String & | materialName = Ogre::BLANKSTRING | ) |

Displays specified material on cursor, or the last material used if none specified.

Used to change cursor type.

References Ogre::BLANKSTRING.

## ◆ hideCursor()

void OgreBites::TrayManager::hideCursor | ( |  | ) |

## ◆ refreshCursor()

void OgreBites::TrayManager::refreshCursor | ( |  | ) |

Updates cursor position based on unbuffered mouse state.

This is necessary because if the tray manager has been cut off from mouse events for a time, the cursor position will be out of date.

## ◆ showTrays()

void OgreBites::TrayManager::showTrays | ( |  | ) |

## ◆ hideTrays()

void OgreBites::TrayManager::hideTrays | ( |  | ) |

## ◆ isCursorVisible()

bool OgreBites::TrayManager::isCursorVisible | ( |  | ) |
| inline

## ◆ isBackdropVisible()

bool OgreBites::TrayManager::isBackdropVisible | ( |  | ) |
| inline

## ◆ areTraysVisible()

bool OgreBites::TrayManager::areTraysVisible | ( |  | ) |
| inline

## ◆ setTrayWidgetAlignment()

void OgreBites::TrayManager::setTrayWidgetAlignment | ( | TrayLocation | trayLoc,
|  | Ogre::GuiHorizontalAlignment | gha )

Sets horizontal alignment of a tray's contents.

## ◆ setWidgetPadding()

void OgreBites::TrayManager::setWidgetPadding | ( | Ogre::Real | padding | ) |

## ◆ setWidgetSpacing()

void OgreBites::TrayManager::setWidgetSpacing | ( | Ogre::Real | spacing | ) |

## ◆ setTrayPadding()

void OgreBites::TrayManager::setTrayPadding | ( | Ogre::Real | padding | ) |

## ◆ getWidgetPadding()

virtual Ogre::Real OgreBites::TrayManager::getWidgetPadding | ( |  | ) | const
| inlinevirtual

## ◆ getWidgetSpacing()

virtual Ogre::Real OgreBites::TrayManager::getWidgetSpacing | ( |  | ) | const
| inlinevirtual

## ◆ getTrayPadding()

virtual Ogre::Real OgreBites::TrayManager::getTrayPadding | ( |  | ) | const
| inlinevirtual

## ◆ adjustTrays()

virtual void OgreBites::TrayManager::adjustTrays | ( |  | ) |
| virtual

Fits trays to their contents and snaps them to their anchor locations.

## ◆ getCursorRay()

Ogre::Ray OgreBites::TrayManager::getCursorRay | ( | Ogre::Camera * | cam | ) |

Returns a 3D ray into the scene that is directly underneath the cursor.

## ◆ createButton()

Button * OgreBites::TrayManager::createButton | ( | TrayLocation | trayLoc,
|  | const Ogre::String & | name,
|  | const Ogre::String & | caption,
|  | Ogre::Real | width = 0 )

## ◆ createTextBox()

TextBox * OgreBites::TrayManager::createTextBox | ( | TrayLocation | trayLoc,
|  | const Ogre::String & | name,
|  | const Ogre::DisplayString & | caption,
|  | Ogre::Real | width,
|  | Ogre::Real | height )

## ◆ createThickSelectMenu()

SelectMenu * OgreBites::TrayManager::createThickSelectMenu | ( | TrayLocation | trayLoc,
|  | const Ogre::String & | name,
|  | const Ogre::DisplayString & | caption,
|  | Ogre::Real | width,
|  | unsigned int | maxItemsShown,
|  | const Ogre::StringVector & | items = Ogre::StringVector() )

## ◆ createLongSelectMenu() [1/2]

SelectMenu * OgreBites::TrayManager::createLongSelectMenu | ( | TrayLocation | trayLoc,
|  | const Ogre::String & | name,
|  | const Ogre::DisplayString & | caption,
|  | Ogre::Real | width,
|  | Ogre::Real | boxWidth,
|  | unsigned int | maxItemsShown,
|  | const Ogre::StringVector & | items = Ogre::StringVector() )

## ◆ createLongSelectMenu() [2/2]

SelectMenu * OgreBites::TrayManager::createLongSelectMenu | ( | TrayLocation | trayLoc,
|  | const Ogre::String & | name,
|  | const Ogre::DisplayString & | caption,
|  | Ogre::Real | boxWidth,
|  | unsigned int | maxItemsShown,
|  | const Ogre::StringVector & | items = Ogre::StringVector() )

## ◆ createLabel()

Label * OgreBites::TrayManager::createLabel | ( | TrayLocation | trayLoc,
|  | const Ogre::String & | name,
|  | const Ogre::DisplayString & | caption,
|  | Ogre::Real | width = 0 )

## ◆ createSeparator()

Separator * OgreBites::TrayManager::createSeparator | ( | TrayLocation | trayLoc,
|  | const Ogre::String & | name,
|  | Ogre::Real | width = 0 )

## ◆ createThickSlider()

Slider * OgreBites::TrayManager::createThickSlider | ( | TrayLocation | trayLoc,
|  | const Ogre::String & | name,
|  | const Ogre::DisplayString & | caption,
|  | Ogre::Real | width,
|  | Ogre::Real | valueBoxWidth,
|  | Ogre::Real | minValue,
|  | Ogre::Real | maxValue,
|  | unsigned int | snaps )

## ◆ createLongSlider() [1/2]

Slider * OgreBites::TrayManager::createLongSlider | ( | TrayLocation | trayLoc,
|  | const Ogre::String & | name,
|  | const Ogre::DisplayString & | caption,
|  | Ogre::Real | width,
|  | Ogre::Real | trackWidth,
|  | Ogre::Real | valueBoxWidth,
|  | Ogre::Real | minValue,
|  | Ogre::Real | maxValue,
|  | unsigned int | snaps )

## ◆ createLongSlider() [2/2]

Slider * OgreBites::TrayManager::createLongSlider | ( | TrayLocation | trayLoc,
|  | const Ogre::String & | name,
|  | const Ogre::DisplayString & | caption,
|  | Ogre::Real | trackWidth,
|  | Ogre::Real | valueBoxWidth,
|  | Ogre::Real | minValue,
|  | Ogre::Real | maxValue,
|  | unsigned int | snaps )

## ◆ createParamsPanel() [1/2]

ParamsPanel * OgreBites::TrayManager::createParamsPanel | ( | TrayLocation | trayLoc,
|  | const Ogre::String & | name,
|  | Ogre::Real | width,
|  | unsigned int | lines )

## ◆ createParamsPanel() [2/2]

ParamsPanel * OgreBites::TrayManager::createParamsPanel | ( | TrayLocation | trayLoc,
|  | const Ogre::String & | name,
|  | Ogre::Real | width,
|  | const Ogre::StringVector & | paramNames )

## ◆ createCheckBox()

CheckBox * OgreBites::TrayManager::createCheckBox | ( | TrayLocation | trayLoc,
|  | const Ogre::String & | name,
|  | const Ogre::DisplayString & | caption,
|  | Ogre::Real | width = 0 )

## ◆ createDecorWidget()

DecorWidget * OgreBites::TrayManager::createDecorWidget | ( | TrayLocation | trayLoc,
|  | const Ogre::String & | name,
|  | const Ogre::String & | templateName )

## ◆ createProgressBar()

ProgressBar * OgreBites::TrayManager::createProgressBar | ( | TrayLocation | trayLoc,
|  | const Ogre::String & | name,
|  | const Ogre::DisplayString & | caption,
|  | Ogre::Real | width,
|  | Ogre::Real | commentBoxWidth )

## ◆ showFrameStats()

void OgreBites::TrayManager::showFrameStats | ( | TrayLocation | trayLoc,
|  | size_t | place = -1 )

Shows frame statistics widget set in the specified location.

## ◆ hideFrameStats()

void OgreBites::TrayManager::hideFrameStats | ( |  | ) |

Hides frame statistics widget set.

## ◆ areFrameStatsVisible()

bool OgreBites::TrayManager::areFrameStatsVisible | ( |  | ) |
| inline

## ◆ toggleAdvancedFrameStats()

void OgreBites::TrayManager::toggleAdvancedFrameStats | ( |  | ) |
| inline

Toggles visibility of advanced statistics.

References labelHit().

## ◆ showLogo()

void OgreBites::TrayManager::showLogo | ( | TrayLocation | trayLoc,
|  | size_t | place = -1 )

Shows logo in the specified location.

## ◆ hideLogo()

void OgreBites::TrayManager::hideLogo | ( |  | ) |

## ◆ isLogoVisible()

bool OgreBites::TrayManager::isLogoVisible | ( |  | ) |
| inline

## ◆ showLoadingBar()

void OgreBites::TrayManager::showLoadingBar | ( | unsigned int | numGroupsInit = 1,
|  | unsigned int | numGroupsLoad = 1,
|  | Ogre::Real | initProportion = 0.7f )

Shows loading bar.

Also takes job settings: the number of resource groups to be initialised, the number of resource groups to be loaded, and the proportion of the job that will be taken up by initialisation. Usually, script parsing takes up most time, so the default value is 0.7.

## ◆ hideLoadingBar()

void OgreBites::TrayManager::hideLoadingBar | ( |  | ) |

## ◆ isLoadingBarVisible()

bool OgreBites::TrayManager::isLoadingBarVisible | ( |  | ) |
| inline

## ◆ showOkDialog()

void OgreBites::TrayManager::showOkDialog | ( | const Ogre::DisplayString & | caption,
|  | const Ogre::DisplayString & | message )

Pops up a message dialog with an OK button.

## ◆ showYesNoDialog()

void OgreBites::TrayManager::showYesNoDialog | ( | const Ogre::DisplayString & | caption,
|  | const Ogre::DisplayString & | question )

Pops up a question dialog with Yes and No buttons.

## ◆ closeDialog()

void OgreBites::TrayManager::closeDialog | ( |  | ) |

Hides whatever dialog is currently showing.

## ◆ isDialogVisible()

bool OgreBites::TrayManager::isDialogVisible | ( |  | ) |

Determines if any dialog is currently visible.

## ◆ getWidget() [1/2]

Widget * OgreBites::TrayManager::getWidget | ( | TrayLocation | trayLoc,
|  | const Ogre::String & | name )

Gets a widget from a tray by name.

Referenced by destroyWidget(), destroyWidget(), moveWidgetToTray(), moveWidgetToTray(), removeWidgetFromTray(), and removeWidgetFromTray().

## ◆ getWidget() [2/2]

Widget * OgreBites::TrayManager::getWidget | ( | const Ogre::String & | name | ) |

Gets a widget by name.

## ◆ getNumWidgets()

unsigned int OgreBites::TrayManager::getNumWidgets | ( |  | ) |

Gets the number of widgets in total.

## ◆ getWidgets()

const WidgetList & OgreBites::TrayManager::getWidgets | ( | TrayLocation | trayLoc | ) | const
| inline

Gets all the widgets of a specific tray.

## ◆ locateWidgetInTray()

int OgreBites::TrayManager::locateWidgetInTray | ( | Widget * | widget | ) |

Gets a widget's position in its tray.

## ◆ destroyWidget() [1/4]

void OgreBites::TrayManager::destroyWidget | ( | Widget * | widget | ) |

Destroys a widget.

Referenced by destroyWidget(), destroyWidget(), and destroyWidget().

## ◆ destroyWidget() [2/4]

void OgreBites::TrayManager::destroyWidget | ( | TrayLocation | trayLoc,
|  | size_t | place )
| inline

References destroyWidget().

## ◆ destroyWidget() [3/4]

void OgreBites::TrayManager::destroyWidget | ( | TrayLocation | trayLoc,
|  | const Ogre::String & | name )
| inline

References destroyWidget(), and getWidget().

## ◆ destroyWidget() [4/4]

void OgreBites::TrayManager::destroyWidget | ( | const Ogre::String & | name | ) |
| inline

References destroyWidget(), and getWidget().

## ◆ destroyAllWidgetsInTray()

void OgreBites::TrayManager::destroyAllWidgetsInTray | ( | TrayLocation | trayLoc | ) |

Destroys all widgets in a tray.

## ◆ destroyAllWidgets()

void OgreBites::TrayManager::destroyAllWidgets | ( |  | ) |

Destroys all widgets.

## ◆ moveWidgetToTray() [1/4]

void OgreBites::TrayManager::moveWidgetToTray | ( | Widget * | widget,
|  | TrayLocation | trayLoc,
|  | size_t | place = -1 )

Adds a widget to a specified tray at given position, or at the end if unspecified or invalid.

Referenced by moveWidgetToTray(), moveWidgetToTray(), moveWidgetToTray(), and removeWidgetFromTray().

## ◆ moveWidgetToTray() [2/4]

void OgreBites::TrayManager::moveWidgetToTray | ( | const Ogre::String & | name,
|  | TrayLocation | trayLoc,
|  | size_t | place = -1 )
| inline

References getWidget(), and moveWidgetToTray().

## ◆ moveWidgetToTray() [3/4]

void OgreBites::TrayManager::moveWidgetToTray | ( | TrayLocation | currentTrayLoc,
|  | const Ogre::String & | name,
|  | TrayLocation | targetTrayLoc,
|  | size_t | place = -1 )
| inline

References getWidget(), and moveWidgetToTray().

## ◆ moveWidgetToTray() [4/4]

void OgreBites::TrayManager::moveWidgetToTray | ( | TrayLocation | currentTrayLoc,
|  | size_t | currentPlace,
|  | TrayLocation | targetTrayLoc,
|  | size_t | targetPlace = -1 )
| inline

References moveWidgetToTray().

## ◆ removeWidgetFromTray() [1/4]

void OgreBites::TrayManager::removeWidgetFromTray | ( | Widget * | widget | ) |
| inline

Removes a widget from its tray.

Same as moving it to the null tray.

References moveWidgetToTray(), and OgreBites::TL_NONE.

Referenced by removeWidgetFromTray(), removeWidgetFromTray(), and removeWidgetFromTray().

## ◆ removeWidgetFromTray() [2/4]

void OgreBites::TrayManager::removeWidgetFromTray | ( | const Ogre::String & | name | ) |
| inline

References getWidget(), and removeWidgetFromTray().

## ◆ removeWidgetFromTray() [3/4]

void OgreBites::TrayManager::removeWidgetFromTray | ( | TrayLocation | trayLoc,
|  | const Ogre::String & | name )
| inline

References getWidget(), and removeWidgetFromTray().

## ◆ removeWidgetFromTray() [4/4]

void OgreBites::TrayManager::removeWidgetFromTray | ( | TrayLocation | trayLoc,
|  | size_t | place )
| inline

References removeWidgetFromTray().

## ◆ clearTray()

void OgreBites::TrayManager::clearTray | ( | TrayLocation | trayLoc | ) |

Removes all widgets from a widget tray.

## ◆ clearAllTrays()

void OgreBites::TrayManager::clearAllTrays | ( |  | ) |

Removes all widgets from all widget trays.

## ◆ frameRendered()

void OgreBites::TrayManager::frameRendered | ( | const Ogre::FrameEvent & | evt | ) |
| overridevirtual

Process frame events.

Updates frame statistics widget set and deletes all widgets queued for destruction.

Reimplemented from OgreBites::InputListener.

## ◆ windowUpdate()

void OgreBites::TrayManager::windowUpdate | ( |  | ) |

Referenced by customStageEnded(), customStageStarted(), resourceGroupLoadStarted(), resourceGroupScriptingStarted(), resourceLoadEnded(), resourceLoadStarted(), scriptParseEnded(), and scriptParseStarted().

## ◆ resourceGroupScriptingStarted()

void OgreBites::TrayManager::resourceGroupScriptingStarted | ( | const Ogre::String & | groupName,
|  | size_t | scriptCount )
| inlineoverridevirtual

This event is fired when a resource group begins parsing scripts.

Note
  Remember that if you are loading resources through ResourceBackgroundQueue, these callbacks will occur in the background thread, so you should not perform any thread-unsafe actions in this callback if that's the case (check the group name / script name).

Parameters

  groupName | The name of the group
  scriptCount | The number of scripts which will be parsed

Reimplemented from Ogre::ResourceGroupListener.

References windowUpdate().

## ◆ scriptParseStarted()

void OgreBites::TrayManager::scriptParseStarted | ( | const Ogre::String & | scriptName,
|  | bool & | skipThisScript )
| inlineoverridevirtual

This event is fired when a script is about to be parsed.

Parameters

  scriptName | Name of the to be parsed
  skipThisScript | A boolean passed by reference which is by default set to false. If the event sets this to true, the script will be skipped and not parsed. Note that in this case the scriptParseEnded event will not be raised for this script.

Reimplemented from Ogre::ResourceGroupListener.

References windowUpdate().

## ◆ scriptParseEnded()

void OgreBites::TrayManager::scriptParseEnded | ( | const Ogre::String & | scriptName,
|  | bool | skipped )
| inlineoverridevirtual

This event is fired when the script has been fully parsed.

Reimplemented from Ogre::ResourceGroupListener.

References windowUpdate().

## ◆ resourceGroupLoadStarted()

void OgreBites::TrayManager::resourceGroupLoadStarted | ( | const Ogre::String & | groupName,
|  | size_t | resourceCount )
| inlineoverridevirtual

This event is fired when a resource group begins loading.

Parameters

  groupName | The name of the group being loaded
  resourceCount | The number of resources which will be loaded, including a number of custom stages required to load anything else

Reimplemented from Ogre::ResourceGroupListener.

References windowUpdate().

## ◆ resourceLoadStarted()

void OgreBites::TrayManager::resourceLoadStarted | ( | const Ogre::ResourcePtr & | resource | ) |
| inlineoverridevirtual

This event is fired when a declared resource is about to be loaded.

Parameters

  resource | Weak reference to the resource loaded.

Reimplemented from Ogre::ResourceGroupListener.

References Ogre::Resource::getName(), and windowUpdate().

## ◆ resourceLoadEnded()

void OgreBites::TrayManager::resourceLoadEnded | ( | void |  | ) |
| inlineoverridevirtual

This event is fired when the resource has been loaded.

Reimplemented from Ogre::ResourceGroupListener.

References windowUpdate().

## ◆ customStageStarted()

void OgreBites::TrayManager::customStageStarted | ( | const Ogre::String & | description | ) |
| inlineoverridevirtual

This event is fired when a custom loading stage is about to start.

The number of stages required will have been included in the resourceCount passed in resourceGroupLoadStarted.

Parameters

  description | Text description of what is about to be done

Reimplemented from Ogre::ResourceGroupListener.

References windowUpdate().

## ◆ customStageEnded()

void OgreBites::TrayManager::customStageEnded | ( | void |  | ) |
| inlineoverridevirtual

This event is fired when a custom loading stage has been completed.

The number of stages required will have been included in the resourceCount passed in resourceGroupLoadStarted.

Reimplemented from Ogre::ResourceGroupListener.

References windowUpdate().

## ◆ labelHit()

void OgreBites::TrayManager::labelHit | ( | Label * | label | ) |
| overridevirtual

Toggles visibility of advanced statistics.

Reimplemented from OgreBites::TrayListener.

Referenced by toggleAdvancedFrameStats().

## ◆ buttonHit()

void OgreBites::TrayManager::buttonHit | ( | Button * | button | ) |
| overridevirtual

Destroys dialog widgets, notifies listener, and ends high priority session.

Reimplemented from OgreBites::TrayListener.

## ◆ mousePressed()

bool OgreBites::TrayManager::mousePressed | ( | const MouseButtonEvent & | evt | ) |
| overridevirtual

Processes mouse button down events.

Returns true if the event was consumed and should not be passed on to other handlers.

Reimplemented from OgreBites::InputListener.

## ◆ mouseReleased()

bool OgreBites::TrayManager::mouseReleased | ( | const MouseButtonEvent & | evt | ) |
| overridevirtual

Processes mouse button up events.

Returns true if the event was consumed and should not be passed on to other handlers.

Reimplemented from OgreBites::InputListener.

## ◆ mouseMoved()

bool OgreBites::TrayManager::mouseMoved | ( | const MouseMotionEvent & | evt | ) |
| overridevirtual

Updates cursor position.

Returns true if the event was consumed and should not be passed on to other handlers.

Reimplemented from OgreBites::InputListener.

## ◆ mouseWheelRolled()

bool OgreBites::TrayManager::mouseWheelRolled | ( | const MouseWheelEvent & | evt | ) |
| overridevirtual

Reimplemented from OgreBites::InputListener.

The documentation for this class was generated from the following file:

- OgreTrays.h